VERSION 5.00
Begin VB.UserControl EmbossLabel 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1320
   Picture         =   "EmbosLbl.ctx":0000
   ScaleHeight     =   80
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   88
   ToolboxBitmap   =   "EmbosLbl.ctx":0446
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      ForeColor       =   &H00000000&
      Height          =   495
      Left            =   480
      Picture         =   "EmbosLbl.ctx":0978
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   49
      TabIndex        =   1
      Top             =   480
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      ForeColor       =   &H00000000&
      Height          =   495
      Left            =   120
      Picture         =   "EmbosLbl.ctx":0DBE
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   49
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   735
   End
End
Attribute VB_Name = "EmbossLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Embossed label control"
Option Explicit

' Enumerated values.
Enum emboss_Style
    N_emboss_Style
    NE_emboss_Style
    E_emboss_Style
    SE_emboss_Style
    S_emboss_Style
    SW_emboss_Style
    W_emboss_Style
    NW_emboss_Style
End Enum

'Default Property Values:
Const m_def_Caption = "EmbossLabel"
Const m_def_EmbossStyle = N_emboss_Style
'Property Variables:
Dim m_Caption As String
Dim m_EmbossStyle As Integer
Dim Kernel(-1 To 1, -1 To 1) As Single

Dim loading As Boolean
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

Public Sub EightBitColorEmboss()
Attribute EightBitColorEmboss.VB_Description = "Applies the filter to the picture."
Const BACK_COLOR = &HC0

Dim bm As BITMAP
Dim hbm As Long
Dim old_bytes() As Byte
Dim new_bytes() As Byte
Dim hpal As Long
Dim wid As Long
Dim hgt As Long
Dim palentry(0 To 255) As PALETTEENTRY

Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single
Dim r As Integer
Dim g As Integer
Dim b As Integer
Dim clr As OLE_COLOR

    ' Do nothing if we're loading.
    If loading Then Exit Sub
    
    ' Place the caption on the picture.
    wid = OrigPict.TextWidth(m_Caption) * 1.1
    hgt = OrigPict.TextHeight(m_Caption) * 1.1
    OrigPict.Width = wid
    OrigPict.Height = hgt
    OrigPict.Line (0, 0)-(wid, hgt), _
        RGB(BACK_COLOR, BACK_COLOR, BACK_COLOR), _
        BF
    OrigPict.CurrentX = wid * 0.05
    OrigPict.CurrentY = hgt * 0.05
    OrigPict.Print m_Caption
    OrigPict.Picture = OrigPict.Image
    UserControl_Resize
    UserControl.Picture = UserControl.Image
    
    ' Get the picture's bitmap.
    hbm = OrigPict.Image
    GetObject hbm, Len(bm), bm
    wid = bm.bmWidthBytes
    hgt = bm.bmHeight
    ReDim old_bytes(0 To wid - 1, 0 To hgt - 1)
    ReDim new_bytes(0 To wid - 1, 0 To hgt - 1)
    GetBitmapBits hbm, wid * hgt, old_bytes(0, 0)
    
    ' Get the picture's palette entries.
    hpal = OrigPict.Picture.hpal
    RealizePalette OrigPict.hdc
    GetSystemPaletteEntries OrigPict.hdc, 0, 256, palentry(0)
    ResizePalette hpal, 256
    ResizePalette UserControl.Picture.hpal, 256
    SetPaletteEntries hpal, 0, 256, palentry(0)
    SetPaletteEntries UserControl.Picture.hpal, 0, 256, palentry(0)

    ' Handle the edges.
    clr = GetNearestPaletteIndex(hpal, _
        RGB(BACK_COLOR, BACK_COLOR, BACK_COLOR) + _
        &H2000000)
    For i = 0 To wid - 1
        new_bytes(i, 0) = clr
        new_bytes(i, hgt - 1) = clr
    Next i
    For j = 0 To hgt - 1
        new_bytes(0, j) = clr
        new_bytes(wid - 1, j) = clr
    Next j
    
    ' Apply the filter.
    For i = 1 To wid - 2
        For j = 1 To hgt - 2
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -1 To 1
                For n = -1 To 1
                    With palentry(old_bytes(i + m, j + n))
                        totr = totr + Kernel(m, n) * .peRed
                        totg = totg + Kernel(m, n) * .peGreen
                        totb = totb + Kernel(m, n) * .peBlue
                    End With
                Next n
            Next m
            totr = CInt(totr) + BACK_COLOR
            totg = CInt(totg) + BACK_COLOR
            totb = CInt(totb) + BACK_COLOR
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            new_bytes(i, j) = _
                GetNearestPaletteIndex(hpal, _
                    RGB(totr, totg, totb) + _
                    &H2000000)
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapBits UserControl.Image, _
        wid * hgt, new_bytes(0, 0)
    UserControl.Refresh
    UserControl.Picture = UserControl.Image
End Sub
Public Sub Emboss()
Const BACK_COLOR = &HC0

Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bg_pixel As RGBTriplet
Dim bits_per_pixel As Integer
Dim wid As Long
Dim hgt As Long
Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single

    ' Do nothing if we're loading.
    If loading Then Exit Sub

    ' Place the caption on the picture.
    wid = OrigPict.TextWidth(m_Caption) * 1.1
    hgt = OrigPict.TextHeight(m_Caption) * 1.1
    OrigPict.Width = wid
    OrigPict.Height = hgt
    OrigPict.Line (0, 0)-(wid, hgt), _
        RGB(BACK_COLOR, BACK_COLOR, BACK_COLOR), _
        BF
    OrigPict.CurrentX = wid * 0.05
    OrigPict.CurrentY = hgt * 0.05
    OrigPict.Print m_Caption
    OrigPict.Picture = OrigPict.Image
    UserControl_Resize
    UserControl.Picture = UserControl.Image

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    wid = UBound(old_pixels, 1) + 1
    hgt = UBound(old_pixels, 2) + 1

    ' Handle the edges.
    bg_pixel.rgbRed = BACK_COLOR
    bg_pixel.rgbGreen = BACK_COLOR
    bg_pixel.rgbBlue = BACK_COLOR
    ReDim new_pixels(0 To wid - 1, 0 To hgt - 1)
    For i = 0 To wid - 1
        new_pixels(i, 0) = bg_pixel
        new_pixels(i, hgt - 1) = bg_pixel
    Next i
    For j = 0 To hgt - 1
        new_pixels(0, j) = bg_pixel
        new_pixels(wid - 1, j) = bg_pixel
    Next j

    ' Apply the filter.
    For i = 1 To wid - 2
        For j = 1 To hgt - 2
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -1 To 1
                For n = -1 To 1
                    With old_pixels(i + m, j + n)
                        totr = totr + Kernel(m, n) * .rgbRed
                        totg = totg + Kernel(m, n) * .rgbGreen
                        totb = totb + Kernel(m, n) * .rgbBlue
                    End With
                Next n
            Next m
            totr = CInt(totr) + BACK_COLOR
            totg = CInt(totg) + BACK_COLOR
            totb = CInt(totb) + BACK_COLOR
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            If totr > 255 Then totr = 255
            If totg > 255 Then totg = 255
            If totb > 255 Then totb = 255
            With new_pixels(i, j)
                .rgbRed = totr
                .rgbGreen = totg
                .rgbBlue = totb
            End With
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

Private Sub OrigPict_Resize()
    picNew.Width = OrigPict.Width
    picNew.Height = OrigPict.Height
End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    loading = True
    
    EmbossStyle = m_def_EmbossStyle
    m_Caption = m_def_Caption
    OrigPict.PSet (0, 0), RGB(&HC0, &HC0, &HC0)
    
    loading = False
    Emboss
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    loading = True
    
    EmbossStyle = PropBag.ReadProperty("EmbossStyle", m_def_EmbossStyle)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    OrigPict.Width = PropBag.ReadProperty("OrigWidth", 100)
    OrigPict.Height = PropBag.ReadProperty("OrigHeight", 100)
    UserControl.Picture = PropBag.ReadProperty("Picture", Nothing)
    
    loading = False
    If UserControl.Picture Is Nothing Then
        UserControl.Picture = OrigPict.Picture
        Emboss
    End If
End Sub
Private Sub UserControl_Resize()
Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    If OrigPict.Picture <> 0 Then
        resizing = True
        Size ScaleX(OrigPict.Width, vbPixels, vbTwips), _
             ScaleY(OrigPict.Height, vbPixels, vbTwips)
        resizing = False
    End If
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("EmbossStyle", m_EmbossStyle, m_def_EmbossStyle)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("OrigWidth", OrigPict.Width, 100)
    Call PropBag.WriteProperty("OrigHeight", OrigPict.Height, 100)
    Call PropBag.WriteProperty("Picture", UserControl.Picture, Nothing)
End Sub
Public Property Get EmbossStyle() As emboss_Style
Attribute EmbossStyle.VB_Description = "Selects a standard filter."
    EmbossStyle = m_EmbossStyle
End Property
Public Property Let EmbossStyle(ByVal New_EmbossStyle As emboss_Style)
Dim i As Integer
Dim j As Integer

    For i = -1 To 1
        For j = -1 To 1
            Kernel(i, j) = 0
        Next j
    Next i
    
    Select Case New_EmbossStyle
        Case N_emboss_Style
            Kernel(0, 1) = 1
            Kernel(0, -1) = -1
        Case NE_emboss_Style
            Kernel(1, -1) = -1
            Kernel(-1, 1) = 1
        Case E_emboss_Style
            Kernel(1, 0) = -1
            Kernel(-1, 0) = 1
        Case SE_emboss_Style
            Kernel(1, 1) = -1
            Kernel(-1, -1) = 1
        Case S_emboss_Style
            Kernel(0, -1) = 1
            Kernel(0, 1) = -1
        Case SW_emboss_Style
            Kernel(1, -1) = 1
            Kernel(-1, 1) = -1
        Case W_emboss_Style
            Kernel(1, 0) = 1
            Kernel(-1, 0) = -1
        Case NW_emboss_Style
            Kernel(1, 1) = 1
            Kernel(-1, -1) = -1
    End Select
    
    m_EmbossStyle = New_EmbossStyle
    PropertyChanged "EmbossStyle"
    Emboss
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = OrigPict.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set OrigPict.Font = New_Font
    PropertyChanged "Font"
    Emboss
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "The string displayed."
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    Emboss
End Property

