VERSION 5.00
Begin VB.UserControl EmbossPicture 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1320
   ScaleHeight     =   1200
   ScaleWidth      =   1320
   ToolboxBitmap   =   "Emboss.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   360
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   120
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   855
   End
End
Attribute VB_Name = "EmbossPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Embossed picture control"
Option Explicit

' Enumerated values.
Enum emboss_Style
    N_emboss_Style
    NE_emboss_Style
    E_emboss_Style
    SE_emboss_Style
    S_emboss_Style
    SW_emboss_Style
    W_emboss_Style
    NW_emboss_Style
End Enum

'Default Property Values:
Const m_def_EmbossStyle = N_emboss_Style
'Property Variables:
Dim m_EmbossStyle As Integer
Dim Kernel(-1 To 1, -1 To 1) As Single
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    
    ' Display the new picture.
    Set UserControl.Picture = New_Picture
    UserControl_Resize
    
    PropertyChanged "Picture"
End Property

Public Sub EightBitColorEmboss()
Const BACK_COLOR = &HC0

Dim bm As BITMAP
Dim hbm As Long
Dim old_bytes() As Byte
Dim new_bytes() As Byte
Dim hpal As Long
Dim wid As Long
Dim hgt As Long
Dim palentry(0 To 255) As PALETTEENTRY

Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single
Dim r As Integer
Dim g As Integer
Dim b As Integer
Dim clr As OLE_COLOR

    ' Get the picture's bitmap.
    hbm = OrigPict.Image
    GetObject hbm, Len(bm), bm
    wid = bm.bmWidthBytes
    hgt = bm.bmHeight
    ReDim old_bytes(0 To wid - 1, 0 To hgt - 1)
    ReDim new_bytes(0 To wid - 1, 0 To hgt - 1)
    GetBitmapBits hbm, wid * hgt, old_bytes(0, 0)
    
    ' Get the picture's palette entries.
    hpal = OrigPict.Picture.hpal
    RealizePalette OrigPict.hdc
    GetSystemPaletteEntries OrigPict.hdc, 0, 256, palentry(0)
    ResizePalette hpal, 256
    ResizePalette UserControl.Picture.hpal, 256
    SetPaletteEntries hpal, 0, 256, palentry(0)
    SetPaletteEntries UserControl.Picture.hpal, 0, 256, palentry(0)

    ' Handle the edges.
    clr = GetNearestPaletteIndex(hpal, _
        RGB(BACK_COLOR, BACK_COLOR, BACK_COLOR) + _
        &H2000000)
    For i = 0 To OrigPict.ScaleWidth - 1
        new_bytes(i, 0) = clr
        new_bytes(i, OrigPict.ScaleHeight - 1) = clr
    Next i
    For j = 0 To OrigPict.ScaleHeight - 1
        new_bytes(0, j) = clr
        new_bytes(OrigPict.ScaleWidth - 1, j) = clr
    Next j
    
    ' Apply the filter.
    For i = 1 To OrigPict.ScaleWidth - 2
        For j = 1 To OrigPict.ScaleHeight - 2
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -1 To 1
                For n = -1 To 1
                    With palentry(old_bytes(i + m, j + n))
                        totr = totr + Kernel(m, n) * .peRed
                        totg = totg + Kernel(m, n) * .peGreen
                        totb = totb + Kernel(m, n) * .peBlue
                    End With
                Next n
            Next m
            totr = CInt(totr) + BACK_COLOR
            totg = CInt(totg) + BACK_COLOR
            totb = CInt(totb) + BACK_COLOR
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            new_bytes(i, j) = _
                GetNearestPaletteIndex(hpal, _
                    RGB(totr, totg, totb) + _
                    &H2000000)
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapBits UserControl.Image, _
        wid * hgt, new_bytes(0, 0)
    UserControl.Refresh
End Sub

Public Sub Emboss()
Const BACK_COLOR = &HC0

Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bg_pixel As RGBTriplet
Dim bits_per_pixel As Integer
Dim wid As Long
Dim hgt As Long
Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim totr As Single
Dim totg As Single
Dim totb As Single

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    wid = UBound(old_pixels, 1) + 1
    hgt = UBound(old_pixels, 2) + 1

    ' Handle the edges.
    bg_pixel.rgbRed = BACK_COLOR
    bg_pixel.rgbGreen = BACK_COLOR
    bg_pixel.rgbBlue = BACK_COLOR
    ReDim new_pixels(0 To wid - 1, 0 To hgt - 1)
    For i = 0 To wid - 1
        new_pixels(i, 0) = bg_pixel
        new_pixels(i, hgt - 1) = bg_pixel
    Next i
    For j = 0 To hgt - 1
        new_pixels(0, j) = bg_pixel
        new_pixels(wid - 1, j) = bg_pixel
    Next j

    ' Apply the filter.
    For i = 1 To wid - 2
        For j = 1 To hgt - 2
            ' Transform pixel (i, j).
            totr = 0
            totg = 0
            totb = 0
            For m = -1 To 1
                For n = -1 To 1
                    With old_pixels(i + m, j + n)
                        totr = totr + Kernel(m, n) * .rgbRed
                        totg = totg + Kernel(m, n) * .rgbGreen
                        totb = totb + Kernel(m, n) * .rgbBlue
                    End With
                Next n
            Next m
            totr = CInt(totr) + BACK_COLOR
            totg = CInt(totg) + BACK_COLOR
            totb = CInt(totb) + BACK_COLOR
            If totr < 0 Then totr = 0
            If totg < 0 Then totg = 0
            If totb < 0 Then totb = 0
            If totr > 255 Then totr = 255
            If totg > 255 Then totg = 255
            If totb > 255 Then totb = 255
            With new_pixels(i, j)
                .rgbRed = totr
                .rgbGreen = totg
                .rgbBlue = totb
            End With
        Next j
        DoEvents
    Next i
    
    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

Private Sub OrigPict_Resize()
    picNew.Width = OrigPict.Width
    picNew.Height = OrigPict.Height
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    EmbossStyle = m_def_EmbossStyle
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set OrigPict.Picture = PropBag.ReadProperty("OrigPict", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("Picture", Nothing)
    EmbossStyle = PropBag.ReadProperty("EmbossStyle", m_def_EmbossStyle)
End Sub
Private Sub UserControl_Resize()
Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    If OrigPict.Picture <> 0 Then
        resizing = True
        Size OrigPict.Width, OrigPict.Height
        resizing = False
    End If
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("OrigPict", OrigPict.Picture, Nothing)
    Call PropBag.WriteProperty("Picture", UserControl.Picture, Nothing)
    Call PropBag.WriteProperty("EmbossStyle", m_EmbossStyle, m_def_EmbossStyle)
End Sub
Public Property Get EmbossStyle() As emboss_Style
Attribute EmbossStyle.VB_Description = "Selects a standard filter."
    EmbossStyle = m_EmbossStyle
End Property
Public Property Let EmbossStyle(ByVal New_EmbossStyle As emboss_Style)
Dim i As Integer
Dim j As Integer

    For i = -1 To 1
        For j = -1 To 1
            Kernel(i, j) = 0
        Next j
    Next i
    
    Select Case New_EmbossStyle
        Case N_emboss_Style
            Kernel(0, 1) = 1
            Kernel(0, -1) = -1
        Case NE_emboss_Style
            Kernel(1, -1) = -1
            Kernel(-1, 1) = 1
        Case E_emboss_Style
            Kernel(1, 0) = -1
            Kernel(-1, 0) = 1
        Case SE_emboss_Style
            Kernel(1, 1) = -1
            Kernel(-1, -1) = 1
        Case S_emboss_Style
            Kernel(0, -1) = 1
            Kernel(0, 1) = -1
        Case SW_emboss_Style
            Kernel(1, -1) = 1
            Kernel(-1, 1) = -1
        Case W_emboss_Style
            Kernel(1, 0) = 1
            Kernel(-1, 0) = -1
        Case NW_emboss_Style
            Kernel(1, 1) = 1
            Kernel(-1, -1) = -1
    End Select
    
    m_EmbossStyle = New_EmbossStyle
    PropertyChanged "EmbossStyle"
End Property
