VERSION 5.00
Begin VB.UserControl RankFilterPicture 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1200
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1320
   ScaleHeight     =   1200
   ScaleWidth      =   1320
   ToolboxBitmap   =   "RankFilt.ctx":0000
   Begin VB.PictureBox picNew 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   360
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.PictureBox OrigPict 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFF00&
      BorderStyle     =   0  'None
      Height          =   735
      Left            =   120
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   57
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   855
   End
End
Attribute VB_Name = "RankFilterPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Rank filter picture control"
Option Explicit

'Default Property Values:
Const m_def_SelectedRank = 1
Const m_def_MaxFilterIndex = 1
'Property Variables:
Dim m_SelectedRank As Integer
Dim m_MaxFilterIndex As Integer
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=OrigPict,OrigPict,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a control."
    Set Picture = OrigPict.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set OrigPict.Picture = New_Picture
    
    ' Display the new picture.
    Set UserControl.Picture = New_Picture
    UserControl_Resize
    
    PropertyChanged "Picture"
End Property

Public Property Get MaxFilterIndex() As Integer
Attribute MaxFilterIndex.VB_Description = "The size of the filter."
    MaxFilterIndex = m_MaxFilterIndex
End Property

Public Property Let MaxFilterIndex(ByVal New_MaxFilterIndex As Integer)
    ' Make sure it's at least 0.
    If New_MaxFilterIndex < 0 Then New_MaxFilterIndex = 0
    m_MaxFilterIndex = New_MaxFilterIndex
    
    ' Reverify SelectedRank is OK.
    SelectedRank = m_SelectedRank
    
    PropertyChanged "MaxFilterIndex"
End Property
Public Sub ApplyFilter()
Attribute ApplyFilter.VB_Description = "Applies the filter to the picture."
Dim old_pixels() As RGBTriplet
Dim new_pixels() As RGBTriplet
Dim bits_per_pixel As Integer
Dim wid As Long
Dim hgt As Long

Dim i As Integer
Dim j As Integer
Dim m As Integer
Dim n As Integer
Dim colors() As RGBTriplet
Dim count As Integer
Dim max As Integer
Dim best_n As Integer
Dim best_brightness As Integer
Dim brightness As Integer
Dim temp_color As RGBTriplet

    ' Get the picture's bitmap.
    GetBitmapPixels OrigPict, old_pixels, bits_per_pixel
    wid = UBound(old_pixels, 1) + 1
    hgt = UBound(old_pixels, 2) + 1
    ReDim new_pixels(0 To wid - 1, 0 To hgt - 1)

    ' Make room to order the palette values.
    max = 2 * m_MaxFilterIndex + 1
    max = max * max
    ReDim colors(1 To max)

    ' Apply the filter.
'@
    For i = m_MaxFilterIndex To wid - 1 - m_MaxFilterIndex
        For j = m_MaxFilterIndex To hgt - 1 - m_MaxFilterIndex
            ' Transform pixel (i, j).
            count = 1
            For m = -m_MaxFilterIndex To m_MaxFilterIndex
                For n = -m_MaxFilterIndex To m_MaxFilterIndex
                    colors(count) = old_pixels(i + m, j + n)
                    count = count + 1
                Next n
            Next m

            ' Order the colors by brightness.
            For m = 1 To max - 1
                best_n = m
                With colors(m)
                    best_brightness = CInt(.rgbRed) + .rgbGreen + .rgbBlue
                End With
                For n = m + 1 To max
                    With colors(n)
                        brightness = CInt(.rgbRed) + .rgbGreen + .rgbBlue
                    End With
                    If best_brightness < brightness Then
                        best_n = n
                        best_brightness = brightness
                    End If
                Next n
                If best_n <> m Then
                    temp_color = colors(best_n)
                    colors(best_n) = colors(m)
                    colors(m) = temp_color
                End If
            Next m

            new_pixels(i, j) = colors(m_SelectedRank)
        Next j
        DoEvents
    Next i

    ' Update the bitmap.
    SetBitmapPixels picNew, bits_per_pixel, new_pixels
    picNew.Picture = picNew.Image
    UserControl.Picture = picNew.Picture
    UserControl.Picture = UserControl.Image
End Sub

Private Sub OrigPict_Resize()
    picNew.Width = OrigPict.Width
    picNew.Height = OrigPict.Height
End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_MaxFilterIndex = m_def_MaxFilterIndex
    m_SelectedRank = m_def_SelectedRank
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set OrigPict.Picture = PropBag.ReadProperty("OrigPict", Nothing)
    Set UserControl.Picture = PropBag.ReadProperty("Picture", Nothing)
    MaxFilterIndex = PropBag.ReadProperty("MaxFilterIndex", m_def_MaxFilterIndex)
    m_SelectedRank = PropBag.ReadProperty("SelectedRank", m_def_SelectedRank)
End Sub
Private Sub UserControl_Resize()
Static resizing As Boolean

    ' Do not recurse.
    If resizing Then Exit Sub
    
    If OrigPict.Picture <> 0 Then
        resizing = True
        Size OrigPict.Width, OrigPict.Height
        resizing = False
    End If
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("OrigPict", OrigPict.Picture, Nothing)
    Call PropBag.WriteProperty("Picture", UserControl.Picture, Nothing)
    Call PropBag.WriteProperty("MaxFilterIndex", m_MaxFilterIndex, m_def_MaxFilterIndex)
    Call PropBag.WriteProperty("SelectedRank", m_SelectedRank, m_def_SelectedRank)
End Sub
Public Property Get SelectedRank() As Integer
Attribute SelectedRank.VB_Description = "The rank to select. Must be between 1 and (2*MaxFilterIndex+1) squared."
    SelectedRank = m_SelectedRank
End Property

Public Property Let SelectedRank(ByVal New_SelectedRank As Integer)
Dim max As Integer

    max = 2 * m_MaxFilterIndex + 1
    max = max * max
    If New_SelectedRank > max Then New_SelectedRank = max
    If New_SelectedRank < 1 Then New_SelectedRank = 1
    
    m_SelectedRank = New_SelectedRank
    PropertyChanged "SelectedRank"
End Property

